import java.io.*;
import java.lang.System;


public class pl0proc {

  public static void main(String[] args) {
    pl0 thisis = new pl0();
    thisis.main(args);
  }
};


class pl0 {

//---------------Podtridy
public class INSTRUCTION
{
 int f;
 int l;
 int a;
} ;

public class TABULKA
{
 String name;
 int kind;
 int val;
 int level; //30
 int adr;
 int size;
 TABULKA() {name = new String();}
};

//---------------Definice
//			konstanty
int NSYM = 35;	            /*pocet rozponatelnych symbolu*/
int NORW = 11;              /*pocet klicovych slov*/
int TMAX = 100;             /*velikost tabulky identifikatoru*/
int NMAX = 14;              /*maximalni pocet cislic v cisle*/
int AL = 10;                /*delka identifikatoru*/
int CHSETSIZE = 128;        /*pocet znaku v mnozine*/
int MAXERR = 30;            /*maximalni pocet chyb*/
int AMAX = 2048;            /*nejvyssi adresa*/
int LEVMAX = 3;             /*maximalni hloubka vnoreni*/
int CXMAX = 200;            /*velikost prostoru pro kod*/
int STACKSIZE = 500;
final int DEBUG=0;

final int
 nullx=0,ident=1,number=2,plus=3,minus=4,times=5,slash=6,modulo=7,oddsym=8,
 eql=9,neq=10,lss=11, leq=12,gtr=13,geq=14,lparen=15,rparen=16,comma=17,
 semicolon=18,period=19,becomes=20,beginsym=21,endsym=22,ifsym=23,thensym=24,
 whilesym=25,dosym=26,callsym=27,constsym=28,varsym=29,procsym=30,
 constant=0,variable=1,procedure=2,
 lit=0,opr=1,lod=2,sto=3,cal=4,ret=5,ing=6,jmp=7,jpc=8,
 neg=0,add=1,sub=2,mul=3,di=4,mod=5,odd=6,eq=7,ne=8,lt=9,ge=10,gt=11,le=12;
//Nahradi enum

char ch;                     /*posledni precteny znak*/

int txpom;                  /*pomocna promenna*/ //74
int sym;         	    /*posledni precteny symbol*/
String id = new String();   /*posledni precteny identifikator*/
int num;                    /*posledni prectene cislo*/
int cc;                     /*pocet znaku*/
int ll;                     /*delka radku*/
int kk,err;
int cx;  /*pocitadlo adres*/
int i;
long pok;
long pokl;
char line[] = new char[81] ;/*nacteny radek*/
String a = new String();
INSTRUCTION code[]; /*pole generovanych kodu*/

String word[]={"begin","call","const","do","end","if","odd","procedure",
		 "then","var","while"};
int wsym[]={beginsym,callsym,constsym,dosym,endsym,ifsym,oddsym,
		   procsym,thensym,varsym,whilesym};
int ssym[] = new int[255];
String mnemonic[]={"LIT  ","OPR  ","LOD  ","STO  ","CAL  ","RET  ","INT  ","JMP  ","JMC  "};
int[] declbegsys = new int[NSYM],statbegsys = new int[NSYM],facbegsys = new int[NSYM];
TABULKA[] TABLE;

int[] pom = new int[NSYM];
char zdrojak[]=new char[13];


RandomAccessFile zdroj;	    /*pomocny soubor pro vypis generovaneho kodu*/
RandomAccessFile iva;       /*a tabulky symbolu*/

///inicializace poli TABLE a code

int cx0,b;
int s[]=new int[STACKSIZE];


/*vynulovat mnozinu symbolu co*/
void nuluj(int[] co) {
 int i;

 for (i=0;i<30;i++) co[i]=0;
}

/*sjednotit dve mnoziny symbolu*/
void sjednot(int[] s1,int[] s2) {
 int i;

 for (i=0;i<30;i++)
  {
	if ((s1[i]!=0)||(s2[i]!=0))
		s1[i]=1;
	else
		s1[i]=0;
  }
}

void listtabsym() { /*pomocna fce pro vypis kon.tvaru tabulky symbolu*/
 int i;

 System.out.print("\n\ntabulka symbolu:\n");
 System.out.print("***************\n");
 for (i=1;i<=txpom;i++) {
  System.out.print("\n");
  System.out.print(i+"  name: "+i+TABLE[i].name);
   switch (TABLE[i].kind) {
   case constant:System.out.print(" const val= "+TABLE[i].val); break;
   case variable:System.out.print(" var   lev= "+TABLE[i].level+"  adr= "+TABLE[i].adr+"  size= "+TABLE[i].size);
		 break;
   case procedure:System.out.print(" proc  lev= "+TABLE[i].level+"  adr= "+TABLE[i].adr+"  size= "+TABLE[i].size);
  }
 }
}

void listgencode() { /*pomocna fce pro vypis generovanych kodu*/
 int i;
 System.out.print((DEBUG==0)?"":"debug1");
 System.out.print("\ngenerovany kod:\n");
 System.out.print("**************\n");
 for (i=0;i<=cx-1;i++)
  System.out.print("\n"+i+" "+mnemonic[code[i].f]+" "+code[i].l+" "+code[i].a);
}

void error(int n) {
 int i;
 System.out.print((DEBUG==0)?"":"debug2");
 System.out.print("****");
 for (i=0;i<cc-1;i++) System.out.print(" ");
 System.out.print(n+"\n");
 if (++err>MAXERR) System.exit(1);
}

/*nacita ze vstupniho souboru 1 znak do glob. promenne 'c' a prekroci konec radky*/
void getch() {
 System.out.print((DEBUG==0)?"":"debug3");
 if (cc==ll) {
 try
 {
  pok=zdroj.getFilePointer();
  pokl=zdroj.length();
  }
 catch (IOException e){System.out.print("exception"+e);}
  if (pok==pokl) {
     System.out.print("program incompleted");
     System.exit(2);
  }

  ll=cc=0;
  System.out.print("       ");
  do {
      try
      {
        ch = (char)zdroj.readByte();
      }
   catch(IOException e){
     System.out.print("chyba cteni");
     System.exit(2);
     }

   if ((ch!='\n')&&(ch!='\r')) {
    line[ll++]=ch;
    System.out.print(ch);
   }
   try
   {
   pok=zdroj.getFilePointer();
   pokl=zdroj.length();
   }
   catch (IOException e) {System.out.print("exception"+e);}
  } while (ch!='\n'&&ch!='\r'&&(pok!=pokl));
  System.out.print("\n");
  line[ll++]=' ';
 }
 ch=line[cc++];
}

/*nacita ze vstupniho souboru 1 symbol a vrati jeho kod do glob. promenne 'sym'*/
void getsym() {
 int i,j,k;
 a=new String();
 System.out.print((DEBUG==0)?"":"debug3");
 while (ch<=' ') getch();
 if (ch>='a'&&ch<='z') {   /*identifier or reserved word*/
  k=0;
  do {
   if (k<AL) a=a+ch;
   getch();
  } while ((ch>='a'&&ch<='z')||(ch>='0'&&ch<='9'));
  id=a;i=0;j=NORW-1;
  do {
   k=(i+j)/2;

   if ((id.compareTo(word[k]))<=0) j=k-1;
   if ((id.compareTo(word[k]))>=0) i=k+1;
  } while (i<=j);
  if ((i-1)>j) sym=wsym[k];
	  else sym=ident;
 } else if (ch>='0'&&ch<='9') {   /*number*/
  k=num=0;sym=number;
  do {
   num=10*num+(ch-'0');
   k++;
   getch();
  } while (ch>='0'&&ch<='9');
  if (k>NMAX) error(30);
 } else if (ch==':') {
  getch();
  if (ch=='=') {
   sym=becomes;
   getch();
  } else sym=nullx;
 } else if (ch=='<') {
  getch();
  if (ch=='=') {
   sym=leq;
   getch();
  } else sym=lss;
 } else if (ch=='>') {
  getch();
  if (ch=='=') {
   sym=geq;
   getch();
  } else sym=gtr;
 } else {
  sym=ssym[ch];
  getch();
 }
}
/*generovat instrukci do pole generovanych kodu
 x	:kod funkce
 y	:uroven instrukce
 z	:adresni cast v instrukci
*/
void gen(int x,int y,int z) {
 System.out.print((DEBUG==0)?"":"debug4");
 if (cx>CXMAX) {
  System.out.print("program too long");
  System.exit(1);
 }
 code[cx].f=x;
 code[cx].l=y;
 code[cx++].a=z;
}

/*testovat zda nacteny symbol je v mnozine symbolu 's1'.
Pokud neni generuje chybu a nacita opakovane ze vstupu
dokud neni nacten pristupny symbol v mnozina 's1' a 's2'*/
void test(int[] s1,int[] s2,int n) {
 System.out.print((DEBUG==0)?"":"debug5");
 int[] pom = new int[NSYM];

 if (s1[sym]==0) {
  error(n);
  nuluj(pom);
  sjednot(pom,s1);
  sjednot(pom,s2);
  while (pom[sym]==0) getsym();
 }
}
/*vlozi object do tabulky symbolu
 k	:typ objektu, tj. zda jde o konstantu,promennou,...
 lev	:uroven, ve ktere je objekt deklarovan
 dx	:adresa objektu
*/
void enter(/*OOBJECT*/ int k,int[] tx,int lev,int[] dx) {
 //(*tx)++;
  System.out.print((DEBUG==0)?"":"debug6");
 tx[0]++;
 TABLE[tx[0]].name=id;
 TABLE[tx[0]].kind=k;
 switch (k) {
  case constant:if (num>AMAX) {
		 error(31);
		 num=0;
		}
		TABLE[tx[0]].val=num;
		break;
  case variable:TABLE[tx[0]].level=lev;
		TABLE[tx[0]].adr=(dx[0])++;
		break;
  case procedure:TABLE[tx[0]].level=lev;
		 break;
 }
}

/*vyhleda symbol v tabulce symbolu
  id	:jmeno symbolu
  tx	:ukazovatko na konec tabulky symbolu
  navratova hodnota:
  -1 : symbol nenalezen
  >=0 : adresa symbolu
*/
int position(String id,int tx) {
 int i;
 System.out.print((DEBUG==0)?"":"debug7");
 TABLE[0].name=id;
 System.out.print((DEBUG==0)?"":"debug7");
 i=tx;
 while (TABLE[i].name==id) i--;
 return i;
}

/*zpracova deklarace konstanty ve tvaru: ident=hodnota.
 tx	:ukazovatko na volne misto v tabulce symbolu
 lev	:uroven, ve ktere je symbol deklarovan
 dx	:adresa - neni pouzita, protoze jde tady o kontantu
*/
void constdeclaration(int[] tx,int lev,int[] dx) {
 System.out.print((DEBUG==0)?"":"debug8");
 if (sym==ident) {
  getsym();
  if (sym==eql||sym==becomes) {
   if (sym==becomes) error(1);
   getsym();
   if (sym==number) {
    enter(constant,tx,lev,dx);
    getsym();
   } else error(2);
  } else error(3);
 } else error(4);
}
/*zpracova deklarace promenne
 tx	:ukazovatko na volne misto v tabulce symbolu
 lev	:uroven,ve ktere je symbol deklarovan
 dx	:adresa promenne
*/
void vardeclaration(int[] tx,int lev,int[] dx) {
 System.out.print((DEBUG==0)?"":"debug9");
 if (sym==ident) {
  enter(variable,tx,lev,dx);
  //System.out.print("debug3-"+variable+"-"+tx[0]+"-"+lev+"-*"+dx[0]+"+");
  getsym();
 } else error(4);
}
/*vypis generovanych kodu prelozeneho bloku*/
void listcode() {
 int i;
 System.out.print((DEBUG==0)?"":"debug10");
 for (i=cx0;i<=(cx-1);i++)
  System.out.print(i+" "+mnemonic[code[i].f]+" "+code[i].l+" "+code[i].a+"\n");
}
/*generovat kod pro ulozeni hodnoty jednoho faktoru na vrcholu zasobniku,
  tj. bud promenna,kontanta,cislo nebo leva zavorka
  fsys	:mnozina dostupnych symbolu
	(tj. faktor muze byt pouze promenna,kontanta,cislo nebo leva zavorka)
  tx	:ukazovatko na konec tabulky symbolu
  lev	:uroven faktoru
*/
void factor(int[] fsys,int tx,int lev) {
 int i;
 System.out.print((DEBUG==0)?"":"debug11");
 int[] pom = new int[NSYM];

 test(facbegsys,fsys,24);
 while (facbegsys[sym]!=0) {
  if (sym==ident) {
   i=position(id,tx);
   if (i==0) error(1);
      else switch (TABLE[i].kind) {
	    case constant:gen(lit,0,TABLE[i].val);break;
	    case variable:gen(lod,lev-TABLE[i].level,TABLE[i].adr);break;
	    case procedure:error(21);break;
	   }
   getsym();
  } else if (sym==number) {
   if (num>AMAX) {
    error(31);
    num=0;
   }
   gen(lit,0,num);
   getsym();
  } else if (sym==lparen) {
   getsym();
   nuluj(pom);
   sjednot(pom,fsys);
   pom[rparen]=1;
   expression(pom,tx,lev);
   if (sym==rparen) getsym();
	       else error(22);
  }
  nuluj(pom);
  pom[lparen]=1;
  test(fsys,pom,23);
 }
}
/*generovat kody pro vypocet jednoho termu,
  tj. pro vyhodnoceni vyrazu ve tvaru faktor*faktor,faktor/faktor nebo faktor%faktor
  fsys	:mnozina dostupnych symbolu ve termu
  tx	:ukazovatko na konec tabulky symbolu
  lev	:uroven termu
*/
void term(int[] fsys,int tx,int lev) {
 int mulop;
 System.out.print((DEBUG==0)?"":"debug12");
 int[] pom = new int[NSYM];

 nuluj(pom);
 sjednot(pom,fsys);
 pom[times]=pom[slash]=pom[modulo]=1;
 factor(pom,tx,lev);
 while (sym==times||sym==slash||sym==modulo) {
  mulop=sym;
  getsym();
  sjednot(pom,fsys);
  pom[times]=pom[slash]=pom[modulo]=1;
  factor(pom,tx,lev);
  switch(mulop) {
    case times: gen(opr,0,mul);break;
    case slash: gen(opr,0,di);break;
    case modulo: gen(opr,0,mod);
  }
 }
}

/*generovat kody pro vyhodnoceni aritm. vyrazu
  fsys	:mnozina dostupnych symbolu ve vyrazu
  tx	:ukazovatko na konec tabulky symbolu
  lev	:uroven vyrazu
*/
void expression(int[] fsys,int tx,int lev) {
 int addop;
 System.out.print((DEBUG==0)?"":"debug12");
 int[] pom = new int[NSYM];

 if (sym==plus||sym==minus) {
  addop=sym;
  getsym();
  nuluj(pom);
  sjednot(pom,fsys);
  pom[plus]=pom[minus]=1;
  term(pom,tx,lev);
  if (addop==minus) gen(opr,0,neg);
 } else {
  nuluj(pom);
  sjednot(pom,fsys);
  pom[plus]=pom[minus]=1;
  term(pom,tx,lev);
 }
 while (sym==plus||sym==minus) {
  addop=sym;
  getsym();
  nuluj(pom);
  sjednot(pom,fsys);
  pom[plus]=pom[minus]=1;
  term(pom,tx,lev);
  if (addop==plus) gen(opr,0,add);
	      else gen(opr,0,sub);
 }
}
/*generovat kody pro vyhodnoceni logickeho vyrazu
  fsys	:dostupne symoboly v vyrazu
  tx	:ukazovatko na konec tabulky symbolu
  lev	:uroven, ve ktere je prelozeny vyraz
*/
void condition(/*SYMSET*/int[] fsys,int tx,int lev) {
 int relop;
 int[] pom = new int[NSYM];
 System.out.print((DEBUG==0)?"":"debug13");
 if (sym==oddsym) {
  getsym();
  expression(fsys,tx,lev);
  gen(opr,0,odd);
 } else {
  nuluj(pom);
  sjednot(pom,fsys);
  pom[eql]=pom[neq]=pom[lss]=pom[gtr]=pom[leq]=pom[geq]=1;
  expression(pom,tx,lev);
  if (sym!=eql&&sym!=neq&&sym!=lss&&sym!=gtr&&sym!=leq&&sym!=geq) error(22);
  else {
   relop=sym;
   getsym();
   expression(fsys,tx,lev);
   switch (relop) {
    case eql:gen(opr,0,eq);break;
    case neq:gen(opr,0,ne);break;
    case lss:gen(opr,0,lt);break;
    case geq:gen(opr,0,ge);break;
    case gtr:gen(opr,0,gt);break;
    case leq:gen(opr,0,le);break;
   }
  }
 }
}

/*generovat kody pro statement
  fsys	:dostupne symboly v statmentu
  tx	:ukazovatko na konec tabulky symbolu
  lev	:uroven, ve ktere je prelozeny statement

*/
void statement(int[] fsys,int tx,int lev) {
 int i,cx1,cx2;
 int[] pom = new int[NSYM];
//System.out.print("debug3-"+fsys[0]+"-"+tx+"-"+lev+"-|");
 System.out.print((DEBUG==0)?"":"debug14"+tx+"//");

 if (fsys[sym]==0 && (sym!=ident)) {
  error(10);
  do
  {
   getsym();
  }
  while (fsys[sym]==0);
 }
 if (sym==ident) {/*nalezen prikaz prirazeni*/
  i=position(id,tx);
  if (i<0) error(11);
  else if (TABLE[i].kind!=variable) { /*prirazeni do jineho ident. nez promenna*/
   error(12);
   i=0;
  }
  getsym();
  if (sym==becomes) getsym();
	       else error(13);
  expression(fsys,tx,lev);
  if (i!=0) gen(sto,lev-TABLE[i].level,TABLE[i].adr);
 } else if (sym==callsym) {/*nalezeno volani podprogramu*/
  getsym();
  if (sym!=ident) error(14);
	     else {
	      if ((i=position(id,tx))==0) error(11);
	      else {
	       if (TABLE[i].kind==procedure) gen(cal,lev-TABLE[i].level,TABLE[i].adr);
					else error(15);
	      }
	      getsym();
	     }
 } else if (sym==ifsym) {/*podmineny prikaz*/
  getsym();
  nuluj(pom);
  sjednot(pom,fsys);
  pom[thensym]=pom[dosym]=1;
  condition(pom,tx,lev);
  if (sym==thensym) getsym();
	       else error(16);
  cx1=cx;
  gen(jpc,0,0);
  statement(fsys,tx,lev);
  code[cx1].a=cx;
 } else if (sym==beginsym) {/*zacina novy blok*/
  getsym();
  nuluj(pom);
  sjednot(pom,fsys);
  pom[semicolon]=pom[endsym]=1;
  statement(pom,tx,lev);
  while ((statbegsys[sym]!=0)||sym==semicolon) {
   if (sym==semicolon) getsym();
		  else error(10);
   sjednot(pom,fsys);
   pom[semicolon]=pom[endsym]=1;
   statement(pom,tx,lev);
  }
  if (sym==endsym) getsym();/*konci predchozi blok*/
	      else error(17);
 } else if (sym==whilesym) {/*zacina cyklus while*/
  cx1=cx;
  getsym();
  nuluj(pom);
  sjednot(pom,fsys);
  pom[dosym]=1;
  condition(pom,tx,lev);
  cx2=cx;
  gen(jpc,0,0);
  if (sym==dosym) getsym();
	     else error(18);
  statement(fsys,tx,lev);
  gen(jmp,0,cx1);
  code[cx2].a=cx;
 }
 test(fsys,pom,19); /*test koreknost ukonceni statementu*/
}

/*generovat kody pro blok ve tvaru
  const a,b,c,..;
  var x,y,z,..;
  podprogramy
  begin
  ...
  end.
  lev	:uroven bloku
  tx	:ukazovatko na konec tabulky symbolu
  fsys	:dostupne symoboly v bloku
*/
void block(int lev,int txset,int[] fsys) {
 int tx0;

 int tx[] = new int[1];
 int dx[] = new int[1];
 System.out.print((DEBUG==0)?"":"debug15");

 dx[0]=0;
 tx[0]=txset;

 int[] pom = new int[NSYM];

 dx[0]=3;tx0=tx[0];TABLE[tx[0]].adr=cx;
 gen(jmp,0,0);
 if (lev>LEVMAX) error(32);
 do {
  if (sym==constsym) {/*deklaracni cast konstant*/
   getsym();
   do {
    constdeclaration(tx,lev,dx);
    while (sym==comma) {
     getsym();
     constdeclaration(tx,lev,dx);
    }
    if (sym==semicolon) getsym();
		   else error(5);
   } while (sym==ident);
  }
  if (sym==varsym) {/*deklaracni cast promennych*/
   getsym();

   vardeclaration(tx,lev,dx);
   while (sym==comma) {
    getsym();
    //System.out.print(sym+comma);
    vardeclaration(tx,lev,dx);
   }
   if (sym==semicolon) getsym();
		  else error(5);
  }
  while (sym==procsym) {/*definice podprogramu*/
   getsym();
   if (sym==ident) {
    enter(procedure,tx,lev,dx);
    //System.out.print("debug3-"+procedure+"-"+tx[0]+"-"+lev+"-*"+dx[0]+"+\n");
    getsym();
   } else error(4);
   if (sym==semicolon) getsym();
		  else error(5);
   nuluj(pom);
   sjednot(pom,fsys);
   pom[semicolon]=1;
   block(lev+1,tx[0],pom);
   if (sym==semicolon) {
    getsym();
    nuluj(pom);
    sjednot(pom,statbegsys);
    pom[ident]=pom[procsym]=1;
    test(pom,fsys,6);
   } else error(5);
  }
  //System.out.print("debug3-"+lev+"-"+tx[0]+"-"+lev+"-*"+dx[0]+"+\n");
  nuluj(pom);
  sjednot(pom,statbegsys);
  pom[ident]=1;
  test(pom,declbegsys,7);
 } while (declbegsys[sym]!=0);
 code[TABLE[tx0].adr].a=cx;
 TABLE[tx0].adr=cx;
 TABLE[tx0].size=dx[0];
 cx0=cx;
 gen(ing,0,dx[0]);
 nuluj(pom);
 sjednot(pom,fsys);
 pom[semicolon]=pom[endsym]=1;
 //System.out.print("debug3-"+fsys[2]+"-"+tx[0]+"-"+lev+"-|");
 statement(pom,tx[0],lev);
 gen(ret,0,0);
 test(fsys,pom,8);
 listcode();
}

/*funkce pro zjisteni pocatecni adresy na urovni
 ktera je o l vyssi nez soucasna uroven, ve ktere je prave vykonan program
*/
  int base(int l) {
 int b1;
 System.out.print((DEBUG==0)?"":"debug16");

 b1=b;
 while (l>0) {
  b1=s[b1];
  l--;
 }
 return b1;
}

/*interpretace generovanych kodu*/
void interpret() {
 int p,t;
 INSTRUCTION i;
 System.out.print((DEBUG==0)?"":"debug17");

 System.out.print("START PL/0\n");
 t=p=s[1]=s[2]=s[3]=0;b=1;
 do {
  i=code[p++];
  switch (i.f) {
   case lit:s[++t]=i.a;break;
   case opr:switch (i.a) {
	     case neg : s[t]=-s[t];
			break;
	     case add : t--;
			s[t]+=s[t+1];
			break;
	     case sub : t--;
			s[t]-=s[t+1];
			break;
	     case mul : t--;
			s[t]*=s[t+1];
			break;
	     case di :  t--;
			s[t]/=s[t+1];
			break;
	     case mod : t--;
			s[t]=s[t]%s[t+1];
			break;
	     case odd : s[t]=s[t]%2;
			break;
	     case eq : t--;
		       s[t]=(s[t]==s[t+1])?1:0;
		       break;
	     case ne : t--;
		       s[t]=(s[t]!=s[t+1])?1:0;
		       break;
	     case lt : t--;
		       s[t]=(s[t]<s[t+1])?1:0;
		       break;
	     case ge : t--;
		       s[t]=(s[t]>=s[t+1])?1:0;
		       break;
	     case gt : t--;
		       s[t]=(s[t]>s[t+1])?1:0;
		       break;
	     case le : t--;
		       s[t]=(s[t]<=s[t+1])?1:0;
		       break;
	    }
	    break;
   case lod:t++;
	    s[t]=s[base(i.l)+i.a];
	    break;
   case sto:s[base(i.l)+i.a]=s[t];
	    System.out.print(s[t--]+"\n");
	    break;
   case cal:s[t+1]=base(i.l);
	    s[t+2]=b;
	    s[t+3]=p;
	    b=t+1;
	    p=i.a;
	    break;
   case ret:t=b-1;
	    p=s[t+3];
	    b=s[t+2];
	    break;
   case ing:t+=i.a;break;
   case jmp:p=i.a;break;
   case jpc:if (s[t]==0) p=i.a;
	    t--;
	    break;
  }
 } while (p!=0);
 System.out.print(" END PL/0\n");//X
}

/*hlavni program*/
int main(String[] args) {
System.out.print( (DEBUG==0)?"":"debug18");

    TABLE = new TABULKA[TMAX+1];
    code = new INSTRUCTION[CXMAX+1];

    for(i=0;i<TMAX+1;i++)
	TABLE[i] = new TABULKA();

    for(i=0;i<CXMAX+1;i++)
	code[i] = new INSTRUCTION();
    System.out.print("---Prekladac PL0---\n");
       try
	{
         iva = new RandomAccessFile("Tab.sym","rw");
        }
       catch (FileNotFoundException e)
        {
         System.out.print("\nSoubor nenalezen\n");
         System.exit(1);
        }

       try
	{
        if (args.length==0)
         zdroj = new RandomAccessFile("zdroj.pl0","r");
        else
         zdroj = new RandomAccessFile(args[0],"r");

	}
	catch (FileNotFoundException s)
	{
	    System.out.print("\nSoubor nenalezen\n");
	    System.exit(1);
	}



       for (ch=' ';ch<='_';ch++) ssym[ch]=0;
       ssym['+']=plus;ssym['-']=minus;ssym['*']=times;ssym['/']=slash;ssym['%']=modulo;
       ssym['(']=lparen;ssym[')']=rparen;ssym['=']=eql;ssym[',']=comma;
       ssym['.']=period;ssym['#']=neq;ssym['<']=lss;ssym['>']=gtr;
       ssym[';']=semicolon;
       nuluj(declbegsys);nuluj(statbegsys);nuluj(facbegsys);
       /*v deklaracni casti se musi zacinat bud 'const','var' nebo 'procedure'*/
       declbegsys[constsym]=declbegsys[varsym]=declbegsys[procsym]=1;
       /*ve statementu se musi zacinat bud 'begin','call','if','while' nebo ident.*/
       statbegsys[beginsym]=statbegsys[callsym]=statbegsys[ifsym]=statbegsys[whilesym]=1;
       /*faktor muze byt bud ident., cislo nebo leva zavorka*/
       facbegsys[ident]=facbegsys[number]=facbegsys[lparen]=1;
       err=cc=cx=ll=0;ch=' ';kk=AL;
       getsym();
       nuluj(pom);
       sjednot(pom,declbegsys);/*program zacina deklaracni casti*/
       sjednot(pom,statbegsys);/*nasleduje cast kodu hlavniho programu*/
       pom[period]=1;
       block(0,0,pom);/*zavola preklad programu*/
       if (sym!=period) error(9);/*a konci teckou*/
       listgencode();
       listtabsym();
       if (err==0) {
        System.out.print("\n Preklad probehl bez chyby\n");
        interpret();/*interpretuje generovane kody, nejsou-li chyby v programu*/
       } else System.out.print("\n "+err+" chyb v programu");

       try {
        iva.close();
        zdroj.close();
       }catch(IOException e) {System.out.print("\nNepodarilo se zavrit soubory\n");}
    return 0;
 }
}
