/* PL0.java - program demonstrujici prekladac a interpret jazyka PL/0
 *
 * Michal Beran, berny@students.zcu.cz
 * 4.1.2001
 */
import pl0prog.*;

import java.util.*;
import java.io.*;


public class PL0 {
	
	/** maximalni pocet znaku v zadavane ceste */
	final int BUFFERSIZE = 50;

	public static void main(String argv[])
	{
		byte[] buffer = new byte[50];
		String FileName;
		if (argv.length > 0) 
		{
			FileName = argv[0];
		}
		else 
		{
			try {
				System.out.print("Prekladac a interpret jazyka PL/0\n\n");
				System.out.print("Zadejte jmeno souboru: ");
				System.in.read(buffer);
				FileName = new String(buffer).trim();
			}		
			catch (IOException e){
				System.out.println("Chyba pri nacitani jmena souboru.");
				return;
			}
		}

		try { 
			// prace se souborem - IOException;

			PL0Compiler comp= new PL0Compiler();	
			comp.Compile(FileName);
			if (comp.getBugBox().getErrorsCount() == 0) 
			{
				PL0Interpret interpret = 
					new PL0Interpret(comp.getSymbolTable(),	comp.getCode());
				interpret.run();
			}
			System.out.println("Pocet chyb v programu: " + 
			   comp.getBugBox().getErrorsCount());
		}
		catch (IOException e) {
			System.out.println("Kriticka chyba, program ukoncen.");		
		}	
		catch (ErrorsException e) {
			// kriticka chyba - prilis mnoho chyb v programu
		}
		
	}
}