/* Locatable.java - popisuje adresovatelne objekty.
 *
 * Michal Beran, berny@students.zcu.cz
 * 4.1.2001
 */

package pl0prog; 

/** Rodicovska abstraktni trida pro identifikatory,
  * jez jsou specifikovany adresou a urovni zanoreni
  */
public abstract class Locatable extends Identifier {

	/** Adresa
	  */
	protected int address;
	/** Uroven zanoreni
	  */
	protected int level;

	/** Vraci aktualni adresu 
	  * @return  vracena adresa 
	  */
	protected int getAddress() {
		return address;
	};

	/** Nastav adresu.
	  * @param adr  pozadovana adresa,
	  */
	protected void setAddress(int adr) {
		address = adr;
	};

	/** Vraci aktualni uroven zanoreni,
	  * @return  vracena uroven zanoreni.
	  */
	protected int getLevel() {
		return level;
	};

	/** Nastav uroven zanoreni.
	  * @param l   vracena uroven zanoreni.
	  */
	protected void setLevel(int l) {
		level = l;
	};

}
